#include "ch32f20x.h"
#include "bsp.h"
#include "debug.h"

//#include "UART.h"


u8 key_event;

u32 time_ms = 0;
void timer_isr();
void key_scan();



u32 bsp_get_time_ms()
{
    return time_ms;
}

void timer_init()
{
    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure={0};
    NVIC_InitTypeDef        NVIC_InitStructure={0};
		
    /* set timer to 1ms */
    RCC_APB1PeriphClockCmd( RCC_APB1Periph_TIM2, ENABLE );

    TIM_TimeBaseInitStructure.TIM_Period = 10000-1;     // 10us * 10000 = 100ms
    TIM_TimeBaseInitStructure.TIM_Prescaler = 480-1; // 48M/480 = 100K
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInit( TIM2, &TIM_TimeBaseInitStructure );
    
		TIM_ClearFlag(TIM2, TIM_IT_Update);
    TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE);    
		TIM_Cmd(TIM2, ENABLE);
    
		NVIC_SetPriorityGrouping(NVIC_PriorityGroup_0);
		NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
		NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
		NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
		NVIC_Init(&NVIC_InitStructure);
}

void timer_isr()
{
    time_ms++;
    if(time_ms%50 == 0)
    {
        key_scan();
    }
}


void BSP_Init(void)
{
    timer_init();    
}


u8 key_event;
void key_scan()
{    
    u8 key_sta,led_sta;
    static u16 long_key_cnt;
    static u8 last_key_sta;

    led_sta = GPIOC->OUTDR&2?1:0;
    GPIOC->BSHR = 2;    
    key_sta = (GPIOC->INDR&2)?1:0;

    if(!led_sta)
        GPIOC->BCR = 2;

    if(last_key_sta != key_sta)
    {
        last_key_sta = key_sta;
        if(key_sta)
        {
            if(key_event != KEYEVENT_LONG)
                key_event = KEYEVENT_SHORT;// short key
            long_key_cnt = 0;
        }
    }

    if(key_sta==0)
    {
        if(long_key_cnt<20)
        {
            long_key_cnt++;
        }
        else
        {
            long_key_cnt = 0;
            key_event = KEYEVENT_LONG;     // long key
        }
    }
}


void bsp_sys_reboot()
{

    NVIC_SystemReset();
}


void TIM2_IRQHandler(void)
{
    if (TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET)
    {
        timer_isr();
        TIM_ClearITPendingBit(TIM2, TIM_IT_Update);
    }
}